<?php

//
// innovaphone fax convert out PHP script
// copyright (c) innovaphone 2012 - 2015
//

$path=dirname(__FILE__);
require_once("$path/../include.php");
require_once("classes/translator.class.php");
require_once("classes/mail/innovaphone.mailbox.class.php");
require_once("$path/../tools/html2text/html2text.php");
require_once("$path/../app-classes/innovaphone.fax.config.class.php");
require_once("$path/../app-classes/innovaphone.fax.database.class.php");
require_once("$path/../app-classes/innovaphone.fax.shm.class.php");
require_once("$path/../app-classes/innovaphone.pbx.class.php");
require_once("$path/../app-classes/innovaphone.pbx.info.class.php");

$version = file_get_contents("$path/../version");

declare(ticks = 1);
?>

innovaphone fax convert out PHP script
copyright (c) innovaphone 2012 - 2014
<?php

print "Version " . $version . "\n\n";

$help = false;
foreach($argv as $arg) {
    if(in_array($arg, array('--help', '-help', '-h', '-?'))) {
        $help = true;
    }
}

if(!is_array($_GET) && ($argc < 3 || $help)) {
?>
    Usage:
  <?php echo $argv[0]; ?> idname> <messageId>

<id> is the configuration database id specific for this server instance.
<messageId> is the message id of the email which should be handled.

With the --help, -help, -h, or -? options, you can get this help.

<?php
exit(1);
} 

$configurationId        = null;
$messageId              = null;

if($argc >= 2) {
    $configurationId    = intval($argv[1]);
    $messageId          = $argv[2];
}
else if(is_array($_GET)) {
    $configurationId    = intval($_GET['id']);
    $messageId          = $_GET['messageId'];
}


setlocale(LC_CTYPE, "en_US.UTF-8");

function getLogDate() {
    $now = new DateTime();
    return date('Ymd-His') . "  -  ";
}

function sig_handler($nsig)
{
    print "\n";
    print getLogDate() . "terminated($nsig).\n";
    exit;
}

pcntl_signal(SIGTERM, "sig_handler", false);
pcntl_signal(SIGINT, "sig_handler", false);
pcntl_signal(SIGHUP, "sig_handler", false);


function createGuid() {
    $time   = explode(" ", microtime());
    $exec       = "/sbin/ifconfig eth0 | grep 'inet addr:' | cut -d: -f2 | awk '{ print $1}'";
    $outputs    = array();
    $ret        = false;
    exec($exec, $outputs, $ret);
    $ip     = explode('.', is_array($outputs) ? $outputs[0] : "");
    $hex    = "";
    for($i = 0; $i <= count($ip) - 1; $i++) {
        $hex .= substr("0" . dechex($ip[$i]), -2);
    }
    
    return sprintf('%08s-%04s-%04x-%08s-%04x',
        substr("00000000" . dechex($time[1]), -8),             // get 8HEX of unixtime
        substr("0000" . dechex(round($time[0] * 65536)), -4),  // get 4HEX of microtime
        mt_rand(0, 0xffff),
        $hex,
        mt_rand(0, 0xffff));
}

function terminateSession(&$pbx) {
    try {
        $p = $pbx->End($pbx->getSession());
    }
    catch(Exception $e) {
        return false;
    }
    return true;
}

function shutdown_function() {
    global $pbx;
    global $faxShm;
    global $jobGuid;
    if($faxShm && $jobGuid) {
        $faxShm->unlockJob($jobGuid);
    }
    if($pbx && $pbx->getKey()) {
        terminateSession($pbx);
    }
    print "\n";
}

register_shutdown_function('shutdown_function');


function checkOfficeProcess() {
    $s = fsockopen("127.0.0.1", 8100);
    if($s) {
        fclose($s);
        return true;
    }
    return false;
}

function handleUserError(&$faxDatabase, &$faxJob, &$mailbox, &$mail, &$cfg, $info) {
    
    //content of info which is used:
    //<type>
    //<command>
    //<command-line>
    //<return-code>
    //<output>
    //<attachment>
    //<language>

    //if <type> is command, <command> is used to find the message.


    print "failed.\n";
    
    $error      = "";
    $type       = "";
    $command    = "";
    $info['<SAP-code>']	= "5001";

    if(array_key_exists('<type>', $info)) {
        $type = $info['<type>'];
    }                    
    if($type == "command") {
        $command    = "Command";
        
        if(array_key_exists('<command>', $info)) {
            $command = $info['<command>'];
        }
        $error      = $command . " failed";
        if(array_key_exists('<command-line>', $info)) {
            print "Command: " . $info['<command-line>'] . "\n";
        }
        if(array_key_exists('<return-code>', $info)) {
            $error .= ", exit code " . $info['<return-code>'];
            print "Return code: " . $info['<return-code>'] . "\n";
        }
        if(array_key_exists('<output>', $info)) {
            print "Output:\n" . $info['<output>'];
        }
    }
    else if($type == 'RightsNoUser') {
        $error = "User not found";
    }
    else if($type == 'RightsNoLicense') {
        $error = "No user license";
    }
    else {
        $error = $type;
    }

    if($mailbox && $mail) {
        $language       = array_key_exists('<language>', $info) ? $info['<language>'] : $cfg->lang;
        $message        = $cfg->getString(FaxServerStrings::msgError, $language);
        
        if($type != "") {
            $message_type   = "FaxServerStrings::msgError" . $type;
            $message1       = defined($message_type) ? $cfg->getString(constant($message_type), $language) : "";
            if($message1 != "") {
                $message    = $message1;
            }
            if($type == "RightsNoUser" || $type == "RightsNoLicense" || $type == "RightsCheckFailed") {
                $info['<SAP-code>']	= "6020";
            }
        }

        if($command != "") {
            $message_type   = "FaxServerStrings::msgError" . $command;
            $message1       = defined($message_type) ? $cfg->getString(constant($message_type), $language) : "";
            if($message1 != "") {
                $message    = $message1;
            }
            else {
                $message_type   = "FaxServerStrings::msgErrorCommand";
                $message1       = defined($message_type) ? $cfg->getString(constant($message_type), $language) : "";
                if($message1 != "") {
                    $message    = $message1;
                }
            }
        }

        if(array_key_exists('<output>', $info)) {
            $output_tl  = "";
            $rows       = explode("\n", $info['<output>']);
            foreach($rows as &$row) {
                $output_tl .= tl::tl($row) . "\n";
            }
            $info['<output>'] = $output_tl;
        }

        if(!array_key_exists('<user-name>', $info) || $info['<user-name>'] == "") {
            $message_type   = "FaxServerStrings::msgUnknownUser";
            $info['<user-name>'] = defined($message_type) ? $cfg->getString(constant($message_type), $language) : "";
        }

        if($cfg->mailSAPCode) {
            $message .= "\n[<SAP-code>]\n";
        }

        $message = strtr($message, $info);
        
        print getLogDate() . "Sending status... ";
        if(!$mailbox->responseMail($mail, $message)) {
            print "failed.\n";
        }
        else {
            print "done.\n";

            print getLogDate() . "Deleting email... ";
            if(!$mailbox->deleteMail($mail->getMessageId())) {
                print "failed.\n";
            }
            else {
                print "done.\n";
            }
        }    
    }
    if($faxDatabase && $faxJob) {
        print getLogDate() . "Updating database... ";
        $faxJob->setProgress('closed');
        $faxJob->setResult('error');
        $faxJob->setErrorCause('by user');
        $faxJob->setErrorDescription($error);
        $faxJob = $faxDatabase->updateFaxJob($faxJob);
        if(!$faxJob) {
            print "failed.\n";
            die("Could not update database object.");
        }
        print "done.\n";
    }
    die($error . "\n");
}

function deleteDocuments($documents = array()) {

    foreach($documents as $document) {

        if(array_key_exists('content file name', $document)) {
            $fileName   = escapeshellcmd($document['content file name']);
            $exec       = "rm -f $fileName 2>&1";
            $outputs    = array();
            $ret        = false;
            exec($exec, $outputs, $ret);
        }
        if(array_key_exists('saved file name', $document)) {
            $fileName   = escapeshellcmd($document['saved file name']);
            $exec       = "rm -f $fileName 2>&1";
            $outputs    = array();
            $ret        = false;
            exec($exec, $outputs, $ret);
        }
        if(array_key_exists('pdf file name', $document)) {
            $fileName   = escapeshellcmd($document['pdf file name']);
            $exec       = "rm -f $fileName 2>&1";
            $outputs    = array();
            $ret        = false;
            exec($exec, $outputs, $ret);
        }
    }
}

$pbx                    = null;
$faxShm                 = null;
$jobGuid                = null;


print getLogDate() . "Reading configuration... ";
$cfg     = new FaxServer();
$cfg->read("", $configurationId);
if(!$cfg) {
    print "failed.\n";
    die("Could not read configuration.");
}
print "done.\n";


tl::change("en");
tl::register("faxserver", dirname(__FILE__) . "/../lang");
tl::change($cfg->lang);


print getLogDate() . "Attaching to shared memory... ";
$faxShm     = new InnovaphoneFaxShm($cfg->shmId);
if(!$faxShm->isAttached()) {
    print "failed.\n";
    die("Could not attach to the SHM.");
}
print "done.\n";


print getLogDate() . "Connecting to database... ";
$faxDatabase    = new InnovaphoneFaxDatabase();
if(!$faxDatabase->isConnected()) {
    print "failed.\n";
    die("Could not connect to the database.");
}
$faxDatabase->setServerId($cfg->id);
print "done.\n";


print getLogDate() . "Connecting to mailbox... ";
$mailbox    = new InnovaphoneMailbox($cfg->mailHost, $cfg->mailPort, $cfg->mailUser, $cfg->mailPassword, $cfg->mailFolder);
if(!$mailbox->isConnected()) {
    print "failed.\n";
    die("Could not connect to the mailbox.");
}
print "done.\n";


print getLogDate() . "Reading email... ";
$mail           = $mailbox->getMail($messageId);
if(!$mail) {
    print "failed.\n";
    die("Could not get email.");
}
print "done.\n";


print getLogDate() . "Checking for existing job... ";
$faxJobs        = $faxDatabase->getFaxJobs(array("message_id" => $messageId));
$faxJob         = null;

if(!$faxJobs || !count($faxJobs)) {
    print "ok.\n";
    do {
        $jobGuid    = createGuid();    
        $faxJob     = $faxDatabase->getFaxJob($jobGuid);
    } while($faxJob);
}
else if(count($faxJobs) == 1) {
    print "found.\n";
    $faxJob = $faxJobs[0];
    $jobGuid = $faxJob->getGuid();
}
else {
    print "found " . count($faxJobs) . " jobs.\n";
    
    $faxJobToProceed = null;
    
    foreach($faxJobs as $count => &$faxJob) {
        if($faxJob->getProgress() == 'created' || 
            $faxJob->getProgress() == 'converted')
        {
            if(!$faxJobToProceed) {
                $faxJobToProceed = &$faxJob;
            }
        }
    }
    if($faxJobToProceed) {
        foreach($faxJobs as $count => &$faxJob) {
            if($faxJob != $faxJobToProceed &&
                $faxJob->getProgress() != 'closed')
            {
                $faxJob->setProgress('closed');
                $faxJob->setResult('error');
                $faxJob->setErrorCause("duplicate job");
                $faxJob->setErrorDescription("duplicate job with same message id");
                $faxJob = $faxDatabase->updateFaxJob($faxJob);
                if(!$faxJob) {
                    die("Could not update database object.");   
                }
            }
        }
        $faxJob = $faxJobToProceed;
        $jobGuid = $faxJob->getGuid();
    }    
}


print getLogDate() . "Trying to lock job... ";
$ret = $faxShm->lockJob($jobGuid, null, $messageId);
if(!$ret) {
    $faxShm = 0;
    print "failed.\n";
    die("Could not lock fax job.");
}
print "done.\n";


if(!$faxJob) {
    print getLogDate() . "Creating new fax job in the database... ";
    $faxJob = $faxDatabase->addFaxJob(new InnovaphoneFaxJob($jobGuid, 'outgoing'));
    if(!$faxJob) {
        print "failed.\n";
        echo pg_last_error();
        die("Could not add database object.");   
    }
    print "done.\n";

    $faxJob->setMessageId($messageId);
    $faxJob = $faxDatabase->updateFaxJob($faxJob);
    if(!$faxJob) {
        die("Could not update database object.");
    }
}


if($faxJob->getDirection() == 'incoming') {
    die("A fax job already exists in database with the email message id and the wrong direction.");
}


$faxRecipients  = array();

foreach($mail->getRecipients() as $recipient) {
    if(!strncmp($recipient->mailbox, "IMCEAFAX-", 9)) {
        $address = quoted_printable_decode(str_replace('+', '=', substr($recipient->mailbox, 9)));
        $number = substr(strrchr($address, '@'), 1);
		if($number == "") {
			$number = $address;
		}
        if(!in_array($number, $faxRecipients)) {
            $faxRecipients[] = $number;
        }
    }
    else if(!strncmp(strtoupper($recipient->mailbox), "FAX=", 4)) {
        $number = substr($recipient->mailbox, 4);
        if(!in_array($number, $faxRecipients)) {
            $faxRecipients[] = $number;
        }
    }
    else if(strtolower($recipient->host) == strtolower($cfg->faxServerDomain)) {
        if(!in_array($recipient->mailbox, $faxRecipients)) {
            $faxRecipients[] = $recipient->mailbox;
        }
    }
}
foreach($mail->getCcRecipients() as $recipient) {
    if(!strncmp($recipient->mailbox, "IMCEAFAX-", 9)) {
        $address = quoted_printable_decode(str_replace('+', '=', substr($recipient->mailbox, 9)));
        $number = substr(strrchr($address, '@'), 1);
		if($number == "") {
			$number = $address;
		}
        if(!in_array($number, $faxRecipients)) {
            $faxRecipients[] = $number;
        }
    }
    else if(!strncmp(strtoupper($recipient->mailbox), "FAX=", 4)) {
        $number = substr($recipient->mailbox, 4);
        if(!in_array($number, $faxRecipients)) {
            $faxRecipients[] = $number;
        }
    }
    else if(strtolower($recipient->host) == strtolower($cfg->faxServerDomain)) {
        if(!in_array($recipient->mailbox, $faxRecipients)) {
            $faxRecipients[] = $recipient->mailbox;
        }
    }
}


if($faxJob->getProgress() == 'created') {
    $faxJob->setUserH323($mail->getSenderAddress());
    $faxJob->setUserName($mail->getSenderName());
    $faxJob = $faxDatabase->updateFaxJob($faxJob);
    if(!$faxJob) {
        die("Could not update database object.");   
    }

    $server     = $cfg->soapHost;
    $port       = $cfg->soapPort;
    $https      = $cfg->https;
    $httpu      = $cfg->soapUser;
    $httpp      = $cfg->soapPassword;
    $userName   = $cfg->soapFaxUser;
    $dynPbxId   = $cfg->soapDynPbx;

    print getLogDate() . "Connecting to PBX " . $server . "... ";
    $pbx = new InnovaphonePBX(
        $server,
        $port,
        $https,
        $httpu,
        $httpp,
        $userName,
        "innovaphone PHP fax convert out [" . $version . "]",
        $cfg->trace ? array("trace" => 1) : null,
        dirname(__FILE__) . '/../wsdl/pbx10_00.wsdl',
        $dynPbxId);
    
    if($pbx->getKey() == 0) {
        print "failed.\n";    
        die("\nFailed to login to PBX: " . $pbx->getFaultString() . "\n");
    }
    print "connected.\n\n";

    $pbx->showVersion();
    print "\n";
    
    try {
        $userHandle = $pbx->UserInitialize($pbx->getSession(), $userName);
        if(!$userHandle) {
            die("Could not subscribe to user {$userName}.\n");
        }
    }
    catch(Exception $e) {
        die("Could not subscribe to user {$userName}.\n");
    }

    $pbxInfo = new InnovaphonePbxInfo($pbx);

    if(!$pbxInfo->initialize()) {
        die("Could not initialize the PBX data.\n");
    }

    $user = $pbxInfo->getUser($userName);
    if(!$user) {
        die("User is not in poll list.\n");
    }

    $pbxInfo->purge();

    $pbxUser = $pbxInfo->findUserH323($faxJob->getUserH323());
    
    if(!$pbxUser) {
        print "user not found(" . $faxJob->getUserH323() . "), ";
        $info = array();
        $info['<type>']         = 'RightsNoUser';
        $info['<sender>']       = $faxJob->getUserName();
        $info['<user-name>']    = $faxJob->getUserName();
        handleUserError($faxDatabase, $faxJob, $mailbox, $mail, $cfg, $info);
    }

    $licensed   = null;

    if($pbxUser->getLocation() != "" && $pbxUser->getLocation() != ".") {
        $locationPbxUrl = "";
        print getLogDate() . "Getting user location URL (" . $pbxUser->getLocation() . ")... ";
        try {
            $locationPbxUrl = $pbx->LocationUrl(true, true, true, true, $pbxUser->getLocation(), $https);
        }
        catch (Exception $e) {
        }
        if($locationPbxUrl != "") {
            print $locationPbxUrl . "\n";
            print getLogDate() . "Connecting to user location PBX...\n";
            $options['location'] = $locationPbxUrl;
            if($cfg->trace) {
                $options['trace'] = 1;
            }
            $locationPbx = new InnovaphonePBX(
                "",
                "",
                $https,
                $httpu,
                $httpp,
                "",
                "innovaphone PHP fax convert out [" . $version . "]",
                $options,
                dirname(__FILE__) . '/../wsdl/pbx10_00.wsdl');
            
            $locationPbx->showVersion();
            print "\n";

            $locationPbxInfo = new InnovaphonePbxInfo($locationPbx);
                
            print getLogDate() . "Checking user rights... ";        
            $licensed        = $locationPbxInfo->userLicense($pbxUser, "Fax");
        }
    }
    else {
        print getLogDate() . "Checking user rights... ";
        $licensed   = $pbxInfo->userLicense($pbxUser, "Fax");
    }

    if(!$licensed) {
        if($licensed === false) {
            print "no license, ";
        }

        $info = array();
        $info['<type>']             = $licensed === false ? 'RightsNoLicense' : 'RightsCheckFailed';
        $info['<sender>']           = $faxJob->getUserName();
        $info['<user-name>']        = $faxJob->getUserName();
        $info['<remote-number>']    = "";
        handleUserError($faxDatabase, $faxJob, $mailbox, $mail, $cfg, $info);
    }
    print "ok.\n";


    $pbxUserName        = $pbxUser->getName();
    $pbxUserNumber      = $pbxUser->getSendNumber() != "" ? $pbxUser->getSendNumber() : $pbxUser->getNumber();
    $pbxUserLocation    = $pbxUser->getLocation();
    $pbxUserLanguage    = $cfg->getLocationLanguage($pbxUserLocation);
    $callerNumber       = $user->getSendNumber() != "" ? $user->getSendNumber() : $user->getNumber();

    if($pbxUser->getPseudoType() == "map") {
        $callerNumber = $pbxUserNumber;
    }
    else if($pbxUser != $user && $cfg->faxAddUserNumber) {
        if(substr($pbxUserNumber, 0, strlen($cfg->faxUserNumberPrefix)) == $cfg->faxUserNumberPrefix) {
            $pbxUserNumber = substr($pbxUserNumber, strlen($cfg->faxUserNumberPrefix) - strlen($pbxUserNumber));
        }
        $callerNumber .= $pbxUserNumber;
    }
    
    $faxJob->setUserName($pbxUserName);
    $faxJob->setUserNumber($callerNumber);
    if($pbxUserLanguage) {
        $faxJob->setUserLanguage($pbxUserLanguage);
    }            
    $faxJob = $faxDatabase->updateFaxJob($faxJob);
    if(!$faxJob) {
        die("Could not update database object.");   
    }

    if(count($faxRecipients) == 0) {
        print getLogDate() . "No recipients. ";
        $info = array();
        $info['<type>']         = 'NoFaxRecipients';
        $info['<sender>']       = $faxJob->getUserName();
        $info['<language>']     = $pbxUserLanguage;
        $info['<user-name>']    = $faxJob->getUserName();
        handleUserError($faxDatabase, $faxJob, $mailbox, $mail, $cfg, $info);
    }    


    $filePath       = FaxConfig::documentPath;
    $jobFileName    = $configurationId . "-outgoing-" . date('Ymd-His') . '-' . $faxJob->getGuid();
    $documents      = array();
    $tnef_documents = array();


    $coverDraft     = $cfg->coverPath($pbxUserLocation);

    $plainText      = $mail->getTextPlain();
    $htmlText       = $mail->getTextHtml();
    $htmlTextEmpty  = true;
    
    if($htmlText != "") {
        try {
            $htmlText = mb_ereg_replace("&nbsp;", "", $htmlText);
            $htmlText = mb_ereg_replace("&#160;", "", $htmlText);
            $htmlText = convert_html_to_text($htmlText);
            if($htmlText != "") {
                $htmlTextEmpty  = false;
            }
            $htmlText = $mail->getTextHtml();
        }
        catch (Exception $e) {
            $htmlText = $mail->getTextHtml();
            $htmlTextEmpty  = false;
        }  
    }

    if($coverDraft != "" && 
        ($mail->getSubject() != "" ||
        $plainText != "" ||
        !$htmlTextEmpty))
    {
        $document                       = array();
        $document['file number']        = 'cover';
        $document['original file name'] = "internal cover page file";
        $document['file extention']     = 'odt';
        $document['file name']          = $jobFileName . '-' . $document['file number'];
        $document['saved file name']    = $filePath . "/" . $document['file name'] . '.' . $document['file extention'];
        $document['pdf file name']      = $filePath . "/" . $document['file name'] . '.pdf';
        
        $cover      = $document['saved file name'];
        
        print getLogDate() . "Copying $coverDraft to $cover... ";
        
        $coverDraft = escapeshellarg($coverDraft);
        $cover      = escapeshellcmd($cover);
        
        $exec       = "cp $coverDraft $cover 2>&1";
        $outputs    = array();
        $ret        = false;

        exec($exec, $outputs, $ret);

        if($ret) {
            $output = "";
            foreach($outputs as &$row) {
                $output .= $row . "\n";
            }
            
            $info                   = array();
            $info['<type>']         = 'command';
            $info['<command>']      = 'Cp';
            $info['<command-line>'] = $exec;
            $info['<output>']       = $output;
            $info['<return-code>']  = $ret;
            $info['<language>']     = $pbxUserLanguage;
            $info['<user-name>']    = $faxJob->getUserName();
            handleUserError($faxDatabase, $faxJob, $mailbox, $mail, $cfg, $info);
        }

        print "done.\n";
        
        
        print getLogDate() . "Opening $cover... ";
        
        $zip = new ZipArchive();
        $ret = $zip->open($cover);
        if($ret !== true) {
            $info                   = array();
            $info['<type>']         = 'Zip';
            $info['<step>']         = tl::tl('open');
            $info['<return-code>']  = $ret;
            $info['<status>']       = $zip->getStatusString();
            $info['<language>']     = $pbxUserLanguage;
            $info['<user-name>']    = $faxJob->getUserName();
            deleteDocuments($documents);
            handleUserError($faxDatabase, $faxJob, $mailbox, $mail, $cfg, $info);
        }
        
        print "done.\n";
        
        
        print getLogDate() . "Patching cover document... ";

        $userVariables = array();
        $plainTextRemoves = array();
        $htmlTextRemoves = array();
        
        $lines = explode("\n", $plainText);
        $countLines = count($lines);
        foreach($lines as $count => &$line) {
            if(substr(ltrim($line), 0, 1) == "@") {
                $varLine = explode("=", $line, 2);
                if(is_array($varLine) && count($varLine) == 2) {
                    $remove = $line . ($countLines == $count + 1 ? "" : "\n");
                    $plainTextRemoves["$remove"] = "";
                    $name = trim(substr(ltrim($varLine[0]), 1));
                    $value = trim($varLine[1]);
                    if($name != "" && $value != "") {
                        $userVariables["$name"] = $value;
                    }
                }
            }
        }
       
        /*
        $lines = explode("\n", $htmlText);
        foreach($lines as $count => &$line) {
            if(substr(ltrim($line), 0, 1) == "@") {
                $varLine = explode("=", $line, 2);
                if(is_array($varLine) && count($varLine) == 2) {
                    $remove = trim($line);
                    $htmlTextRemoves["$remove"] = "";
                    $name = trim(substr(ltrim($varLine[0]), 1));
                    $value = trim($varLine[1]);
                    if($name != "" && $value != "") {
                        $userVariables["$name"] = $value;
                    }
                }
            }
        }
        */
        
        $nextPos = strpos($htmlText, ">@", 0);
        while($nextPos !== false) {
            $closePos = strpos($htmlText, "<", $nextPos);
            if($closePos !== false) {
                $line = substr($htmlText, $nextPos + 2, $closePos - $nextPos - 2);
                $varLine = explode("=", $line, 2);
                if(is_array($varLine) && count($varLine) == 2) {
                    $remove = '@' . $line;
                    if(strcmp(substr($htmlText, $closePos, 4), "<br>") === 0) {
                        $remove .= "<br>";
                    }
                    elseif(strcmp(substr($htmlText, $closePos, 5), "<br/>") === 0) {
                        $remove .= "<br/>";
                    }
                    $htmlTextRemoves["$remove"] = "";
                    $name = trim(substr(ltrim($varLine[0]), 1));
                    $value = trim($varLine[1]);
                    if($name != "" && $value != "") {
                        $userVariables["$name"] = $value;
                    }
                }
            }
            $nextPos = strpos($htmlText, ">@", $nextPos + 1);
        }
        
        $content = $zip->getFromName('content.xml');
        if($content === false) {
            $info                   = array();
            $info['<type>']         = 'Zip';
            $info['<step>']         = tl::tl('read file');
            $info['<return-code>']  = 0;
            $info['<status>']       = $zip->getStatusString();
            $info['<language>']     = $pbxUserLanguage;
            $info['<user-name>']    = $faxJob->getUserName();
            deleteDocuments($documents);
            handleUserError($faxDatabase, $faxJob, $mailbox, $mail, $cfg, $info);
        }
        
        $priority       = tl::tl("As soon as possible");
        if($mail->getPriority() == "urgent") {
            $priority   = tl::tl("Urgent");
        }
        else if($mail->getPriority() == "non-urgent") {
            $priority   = tl::tl("For your information");
        }
        $recipients     = "";
        $count          = 0;
        foreach($mail->getRecipients() as $recipient) {
            if($count) {
                $recipients .= "; ";
            }
            if(!strncmp($recipient->mailbox, "IMCEAFAX-", 9)) {
                $address = quoted_printable_decode(str_replace('+', '=', substr($recipient->mailbox, 9)));
                $number = substr(strrchr($address, '@'), 1);
                $name = utf8_encode(substr($address, 0, strlen($address) - strlen($number) - 1));
				if($number != "") {
					$recipients .= $name . " (" . $number . ")";
				}
				else {
					$recipients .= $name;
				}
            }
            else if(strtolower($recipient->host) == strtolower($cfg->faxServerDomain)) {
                $recipients .= $recipient->mailbox;
            }
            else {
                $recipients .= $recipient->personal . ' <' . $recipient->mailbox . '@' . $recipient->host . '>';
            }
            $count++;
        }
        $ccRecipients     = "";
        $count          = 0;
        foreach($mail->getCcRecipients() as $recipient) {
            if($count) {
                $ccRecipients .= "; ";
            }
            if(!strncmp($recipient->mailbox, "IMCEAFAX-", 9)) {
                $address = quoted_printable_decode(str_replace('+', '=', substr($recipient->mailbox, 9)));
                $number = substr(strrchr($address, '@'), 1);
                $name = utf8_encode(substr($address, 0, strlen($address) - strlen($number) - 1));
				if($number != "") {
					$ccRecipients .= $name . ' (' . $number . ')';
				}
				else {
					$ccRecipients .= $name;
				}
            }
            else if(strtolower($recipient->host) == strtolower($cfg->faxServerDomain)) {
                $ccRecipients .= $recipient->mailbox;
            }
            else {
                $ccRecipients .= $recipient->personal . ' <' . $recipient->mailbox . '@' . $recipient->host . '>';
            }
            $count++;
        }
        
        $contentInfo    = array();
        $contentInfo[htmlspecialchars('<subject>', ENT_QUOTES, 'UTF-8')]         = htmlspecialchars($mail->getSubject(), ENT_QUOTES, 'UTF-8');
        $contentInfo[htmlspecialchars('<user-name>', ENT_QUOTES, 'UTF-8')]       = htmlspecialchars($faxJob->getUserName(), ENT_QUOTES, 'UTF-8');
        $contentInfo[htmlspecialchars('<user-mail>', ENT_QUOTES, 'UTF-8')]       = htmlspecialchars($faxJob->getUserH323(), ENT_QUOTES, 'UTF-8');
        $contentInfo[htmlspecialchars('<date>', ENT_QUOTES, 'UTF-8')]            = htmlspecialchars(InputPageDateField::translateDate($mail->getDate()->getTimestamp()), ENT_QUOTES, 'UTF-8');
        $contentInfo[htmlspecialchars('<time>', ENT_QUOTES, 'UTF-8')]            = htmlspecialchars($mail->getDate()->format("H:i"), ENT_QUOTES, 'UTF-8');
        $contentInfo[htmlspecialchars('<priority>', ENT_QUOTES, 'UTF-8')]        = htmlspecialchars($priority, ENT_QUOTES, 'UTF-8');
        $contentInfo[htmlspecialchars('<recipients>', ENT_QUOTES, 'UTF-8')]      = htmlspecialchars($recipients, ENT_QUOTES, 'UTF-8');
        $contentInfo[htmlspecialchars('<ccrecipients>', ENT_QUOTES, 'UTF-8')]    = htmlspecialchars($ccRecipients, ENT_QUOTES, 'UTF-8');

        $contentInfo['<text:user-field-decl office:value-type="string" office:string-value="" text:name="Date"/>'] = 
            '<text:user-field-decl office:value-type="string" office:string-value="' . 
            htmlspecialchars(InputPageDateField::translateDate($mail->getDate()->getTimestamp()), ENT_QUOTES, 'UTF-8') . '" text:name="Date"/>';
        $contentInfo['<text:user-field-decl office:value-type="string" office:string-value="" text:name="Time"/>'] = 
            '<text:user-field-decl office:value-type="string" office:string-value="' . $mail->getDate()->format("H:i") . '" text:name="Time"/>';
        $mailDate = $mail->getDate();
        $mailDate->setTimezone(new DateTimeZone("CET"));
        $contentInfo['<text:user-field-decl office:value-type="float" office:value="0" text:name="Date"/>'] = 
            '<text:user-field-decl office:value-type="float" office:value="' . 
            (0.0 + date_diff($mailDate, new DateTime('1899-12-30'))->days + ($mailDate->format("H") * 60 + $mailDate->format("i")) / (24 * 60)) . 
            '" text:name="Date"/>';
        $contentInfo['<text:user-field-decl office:value-type="float" office:value="0" text:name="Time"/>'] = 
            '<text:user-field-decl office:value-type="float" office:value="' . 
            (0.0 + date_diff($mailDate, new DateTime('1899-12-30'))->days + ($mailDate->format("H") * 60 + $mailDate->format("i")) / (24 * 60)) . 
            '" text:name="Time"/>';
        $contentInfo['<text:user-field-decl office:value-type="string" office:string-value="" text:name="UserName"/>'] = 
            '<text:user-field-decl office:value-type="string" office:string-value="' . htmlspecialchars($faxJob->getUserName(), ENT_QUOTES, 'UTF-8') . '" text:name="UserName"/>';
        $contentInfo['<text:user-field-decl office:value-type="string" office:string-value="" text:name="UserMail"/>'] = 
            '<text:user-field-decl office:value-type="string" office:string-value="' . htmlspecialchars($faxJob->getUserH323(), ENT_QUOTES, 'UTF-8') . '" text:name="UserMail"/>';
        $contentInfo['<text:user-field-decl office:value-type="string" office:string-value="" text:name="Recipients"/>'] = 
            '<text:user-field-decl office:value-type="string" office:string-value="' . htmlspecialchars($recipients, ENT_QUOTES, 'UTF-8') . '" text:name="Recipients"/>';
        $contentInfo['<text:user-field-decl office:value-type="string" office:string-value="" text:name="CcRecipients"/>'] = 
            '<text:user-field-decl office:value-type="string" office:string-value="' . htmlspecialchars($ccRecipients, ENT_QUOTES, 'UTF-8') . '" text:name="CcRecipients"/>';
        $contentInfo['<text:user-field-decl office:value-type="string" office:string-value="" text:name="Priority"/>'] = 
            '<text:user-field-decl office:value-type="string" office:string-value="' . htmlspecialchars($priority, ENT_QUOTES, 'UTF-8') . '" text:name="Priority"/>';
        $contentInfo['<text:user-field-decl office:value-type="string" office:string-value="" text:name="Subject"/>'] = 
            '<text:user-field-decl office:value-type="string" office:string-value="' . htmlspecialchars($mail->getSubject(), ENT_QUOTES, 'UTF-8') . '" text:name="Subject"/>';

        foreach($userVariables as $variableName => &$variableValue) {
            $contentInfoName  = "<text:user-field-decl office:value-type=\"string\" office:string-value=\"\" text:name=\"" . htmlspecialchars($variableName) . "\"/>";
            $contentInfoValue = "<text:user-field-decl office:value-type=\"string\" office:string-value=\"" . 
                htmlspecialchars($variableValue, ENT_QUOTES, 'UTF-8') . "\" text:name=\"" . htmlspecialchars($variableName) . "\"/>";
            $contentInfo["$contentInfoName"] = $contentInfoValue;
        }
        
        $content = strtr($content, $contentInfo);
        
        $ret = $zip->deleteName('content.xml');
        if($ret !== true) {
            $info                   = array();
            $info['<type>']         = 'Zip';
            $info['<step>']         = tl::tl('delete file');
            $info['<return-code>']  = $ret;
            $info['<status>']       = $zip->getStatusString();
            $info['<language>']     = $pbxUserLanguage;
            $info['<user-name>']    = $faxJob->getUserName();
            deleteDocuments($documents);
            handleUserError($faxDatabase, $faxJob, $mailbox, $mail, $cfg, $info);
        }
        
        $ret = $zip->addFromString('content.xml', $content);
        if($ret !== true) {
            $info                   = array();
            $info['<type>']         = 'Zip';
            $info['<step>']         = tl::tl('add file');
            $info['<return-code>']  = $ret;
            $info['<status>']       = $zip->getStatusString();
            $info['<language>']     = $pbxUserLanguage;
            $info['<user-name>']    = $faxJob->getUserName();
            deleteDocuments($documents);
            handleUserError($faxDatabase, $faxJob, $mailbox, $mail, $cfg, $info);
        }

        $zip->close();

        print "done.\n";


        if($cfg->faxCoverIncludesUserText) {
            print getLogDate() . "Writing content to file... ";
            if($htmlTextEmpty) {
                $content = $mail->getTextPlain();
                $content = strtr($content, $plainTextRemoves);
                $document['content file name'] = $filePath . "/" . $document['file name'] . '.txt';
            }
            else {
                $content = $mail->getTextHtml();
                $content = strtr($content, $htmlTextRemoves);
                $document['content file name'] = $filePath . "/" . $document['file name'] . '.html';
                if(strncasecmp($content, "<html ", 6) != 0 && strncasecmp($content, "<meta ", 6) != 0) {
                    $content = "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=" . $mail->getTextHtmlCharset() . "\">" . $content;
                }
            }
            
            $documents[] = $document;
            
            $contentFile = fopen($document['content file name'], 'w');
            $ret = fwrite($contentFile, $content);
            if($ret === false) {
                $info                   = array();
                $info['<type>']         = 'Command';
                $info['<step>']         = tl::tl('write HTML content file');
                $info['<language>']     = $pbxUserLanguage;
                $info['<user-name>']    = $faxJob->getUserName();
                deleteDocuments($documents);
                handleUserError($faxDatabase, $faxJob, $mailbox, $mail, $cfg, $info);
            }
            fclose($contentFile);

            unset($document);

            print "done.\n";
        }
        else {
            $documents[] = $document;
            unset($document);
        }
    }


    $attachments    = $mail->getAttachments();
    $counter        = 0;

    if(is_array($attachments) && count($attachments) != 0) {

        print getLogDate() . "Saving attachments... ";
        foreach($attachments as &$attachment) {
            if($attachment->getType() != 1 &&
               $attachment->getType() != 4 &&
               $attachment->getType() != 6) {
                $document                       = array();
                $document['file number']        = $counter;
                $document['original file name'] = $attachment->getFileName();
                $document['file extention']     = strtolower($attachment->getFileExtension());
                $document['file name']          = $jobFileName . '-' . $document['file number'];
                $document['saved file name']    = $filePath . "/" . $document['file name'] . '.' . $document['file extention'];
                if(!$mailbox->saveAttachment($mail, $attachment, $document['saved file name'])) {
                    var_dump($attachment);
                    var_dump($mail);
                    $info                   = array();
                    $info['<type>']         = 'ReadAttachment';
                    $info['<attachment>']   = $document['original file name'];
                    $info['<language>']     = $pbxUserLanguage;
                    $info['<user-name>']    = $faxJob->getUserName();
                    deleteDocuments($documents);
                    handleUserError($faxDatabase, $faxJob, $mailbox, $mail, $cfg, $info);
                }
                if($attachment->getSubtype() == "ms-tnef") {
                    $tnef_documents[] = $document;
                }
                else {             
                    $document['pdf file name']      = $filePath . "/" . $document['file name'] . '.pdf';
                    $documents[] = $document;
                    $counter++;
                }
            }
        }
        
        print "done.\n";
    }

    if(count($tnef_documents) != 0) {
        print getLogDate() . "Extracting ms-tnef documents... ";

        foreach($tnef_documents as &$tnef_document) {
            $tnefDirectory  = escapeshellcmd($filePath . "/" . $jobFileName . '-' . $document['file number']);
            $exec           = "mkdir $tnefDirectory 2>&1";
            $outputs        = array();
            $ret            = false;
            
            exec($exec, $outputs, $ret);
            if($ret) {
                $output = "";
                foreach($outputs as &$row) {
                    $output .= $row . "\n";
                }
                $info                   = array();
                $info['<type>']         = 'command';
                $info['<command>']      = 'Mkdir';
                $info['<command-line>'] = $exec;
                $info['<output>']       = $output;
                $info['<return-code>']  = $ret;
                $info['<attachment>']   = $tnef_document['original file name'];
                $info['<language>']     = $pbxUserLanguage;
                $info['<user-name>']    = $faxJob->getUserName();
                deleteDocuments(array_merge($documents, $tnef_documents));
                handleUserError($faxDatabase, $faxJob, $mailbox, $mail, $cfg, $info);
            }

            $tnefFile       = escapeshellcmd($tnef_document['saved file name']);
            $exec           = "/usr/bin/tnef --number-backups -v -f $tnefFile -C $tnefDirectory 2>&1";
            $outputs        = array();
            $ret            = false;
            
            exec($exec, $outputs, $ret);
            if($ret) {
                $output = "";
                foreach($outputs as &$row) {
                    $output .= $row . "\n";
                }
                $info                   = array();
                $info['<type>']         = 'command';
                $info['<command>']      = 'Tnef';
                $info['<command-line>'] = $exec;
                $info['<output>']       = $output;
                $info['<return-code>']  = $ret;
                $info['<attachment>']   = $tnef_document['original file name'];
                $info['<language>']     = $pbxUserLanguage;
                $info['<user-name>']    = $faxJob->getUserName();
                deleteDocuments(array_merge($documents, $tnef_documents));
                handleUserError($faxDatabase, $faxJob, $mailbox, $mail, $cfg, $info);
            }

            $tnefFiles = $outputs;
            
            foreach($tnefFiles as &$row) {
                $file           = trim(strtok($row . "\t|\t", "\t|\t"));
                $savedFile      = trim(strtok("\t|\t"));
                $fileName       = $file;
                $fileExtention  = "";
                $split_position = strrpos($file, '.');
                if($split_position) {
                    $fileName       = substr($file, 0, $split_position);
                    $fileExtention  = $split_position < strlen($file) ? substr($file, $split_position + 1) : "";
                }
                $document                       = array();
                $document['file number']        = $counter;
                $document['original file name'] = $tnef_document['original file name'] . '/' . $file;
                $document['file extention']     = strtolower($fileExtention);
                $document['file name']          = $jobFileName . '-' . $document['file number'];
                $document['saved file name']    = $filePath . "/" . $document['file name'] . '.' . $document['file extention'];
                $document['pdf file name']      = $filePath . "/" . $document['file name'] . '.pdf';

                $exec           = "mv $savedFile " . $document['saved file name'] . " 2>&1";
                $outputs        = array();
                $ret            = false;
                
                exec($exec, $outputs, $ret);
                if($ret) {
                    $output = "";
                    foreach($outputs as &$row) {
                        $output .= $row . "\n";
                    }
                    $info                   = array();
                    $info['<type>']         = 'command';
                    $info['<command>']      = 'Mv';
                    $info['<command-line>'] = $exec;
                    $info['<output>']       = $output;
                    $info['<return-code>']  = $ret;
                    $info['<attachment>']   = $document['original file name'];
                    $info['<language>']     = $pbxUserLanguage;
                    $info['<user-name>']    = $faxJob->getUserName();
                    deleteDocuments(array_merge($documents, $tnef_documents));
                    handleUserError($faxDatabase, $faxJob, $mailbox, $mail, $cfg, $info);
                }

                $documents[] = $document;
                $counter++;
            }

            $exec           = "rm $tnefFile 2>&1";
            $outputs        = array();
            $ret            = false;
            exec($exec, $outputs, $ret);

            $exec           = "rm -r $tnefDirectory 2>&1";
            $outputs        = array();
            $ret            = false;
            exec($exec, $outputs, $ret);
        }
        
        print "done.\n";
    }

    if(count($documents) == 0) {
        $info                   = array();
        $info['<type>']         = 'NoAttachment';
        $info['<language>']     = $pbxUserLanguage;
        $info['<user-name>']    = $faxJob->getUserName();
        handleUserError($faxDatabase, $faxJob, $mailbox, $mail, $cfg, $info);
    }

    foreach($documents as &$document) {
        if($document['file extention'] == "tiff" || $document['file extention'] == "tif") {

            print getLogDate() . "Converting " . $document['saved file name'] . " to " . $document['pdf file name'] . '... ';

            $fileTiff       = $document['saved file name'];
            $fileConverted  = $document['pdf file name'];
            $exec           = "tiff2pdf -pA4 -n -d $fileTiff > " . escapeshellarg($fileConverted);
            $outputs        = array();
            $ret            = false;

            exec($exec, $outputs, $ret);

            if($ret) {
                $output = "";
                foreach($outputs as &$row) {
                    $output .= $row . "\n";
                }
                
                $info                   = array();
                $info['<type>']         = 'command';
                $info['<command>']      = 'Tiff2pdf';
                $info['<command-line>'] = $exec;
                $info['<output>']       = $output;
                $info['<return-code>']  = $ret;
                $info['<attachment>']   = $document['original file name'];
                $info['<language>']     = $pbxUserLanguage;
                $info['<user-name>']    = $faxJob->getUserName();
                deleteDocuments($documents);
                handleUserError($faxDatabase, $faxJob, $mailbox, $mail, $cfg, $info);
            }

            print "done.\n";
        }
        else if($document['saved file name'] != $document['pdf file name']) {
            if(!checkOfficeProcess()) {
                print getLogDate() . "Starting OpenOffice... ";
                
                $exec = "/usr/bin/sudo /usr/local/bin/config.sh soffice";
                $ret = 0;
                $output = MainMethods::callConfigSh($exec, $ret);

                $i = 0;
                while(!checkOfficeProcess() && $i++ < 20) {
                    sleep(1);
                }
                if($i >= 20) {
                    $output                 = "response timeout: $output";
                    $info                   = array();
                    $info['<type>']         = 'command';
                    $info['<command>']      = 'OpenOffice';
                    $info['<command-line>'] = $exec;
                    $info['<output>']       = $output;
                    $info['<return-code>']  = $ret;
                    $info['<attachment>']   = $document['original file name'];
                    $info['<language>']     = $pbxUserLanguage;
                    $info['<user-name>']    = $faxJob->getUserName();
                    deleteDocuments($documents);
                    handleUserError($faxDatabase, $faxJob, $mailbox, $mail, $cfg, $info);
                }                
                print "done.\n";
            }

            print getLogDate() . "Converting " . $document['saved file name'] . " to " . $document['pdf file name'] . '... ';
            
            $fileConvert    = escapeshellcmd($document['saved file name']);
            $exec           = "HOME=/tmp " . $path . DIRECTORY_SEPARATOR . ".." . DIRECTORY_SEPARATOR . "unoconv -v -p 8100 -s 127.0.0.1";
            if(array_key_exists('content file name', $document)) {
                $exec       .= " -a " . $document['content file name'];
            }
            $exec           .= " $fileConvert 2>&1";
            
            $outputs        = array();
            $ret            = false;
            
            exec($exec, $outputs, $ret);
            
            if($ret == 251) {
                $outputs        = array();
                $ret            = false;
                
                exec($exec, $outputs, $ret);
            }
            
            if($ret) {
                $output = "";
                foreach($outputs as &$row) {
                    $output .= $row . "\n";
                }
                
                $info                   = array();
                $info['<type>']         = 'command';
                $info['<command>']      = 'Unoconv';
                $info['<command-line>'] = $exec;
                $info['<output>']       = $output;
                $info['<return-code>']  = $ret;
                $info['<attachment>']   = $document['original file name'];
                $info['<language>']     = $pbxUserLanguage;
                $info['<user-name>']    = $faxJob->getUserName();
                deleteDocuments($documents);
                handleUserError($faxDatabase, $faxJob, $mailbox, $mail, $cfg, $info);
            }
            
            print "done.\n";
        }
        else {
            unset($document['saved file name']);
        }
    }

    $filePdf            = escapeshellcmd($filePath . "/" . $jobFileName . '.pdf');
    $fileSff            = escapeshellcmd($filePath . "/" . $jobFileName . '.sff');
    $fileWebdavLocal    = escapeshellcmd(FaxConfig::webdavPath . "/" . $jobFileName . '.sff');
    $fileWebdav         = $cfg->webdavURL . "/" . $jobFileName . '.sff';


    if(count($documents) > 1) {
        
        print getLogDate() . "Concatenating " . count($documents) . " PDFs to $filePdf... ";
        
        $exec     = "gs -q -dNOPAUSE -dBATCH -sDEVICE=pdfwrite -sOUTPUTFILE=$filePdf ";
        foreach($documents as &$document) {
            $exec .= $document['pdf file name'] . " ";
        }        
        $exec .= "2>&1";

        $outputs    = array();
        $ret        = false;
        exec($exec, $outputs, $ret);

        if($ret) {
            $output = "";
            foreach($outputs as &$row) {
                $output .= $row . "\n";
            }
            
            $info                   = array();
            $info['<type>']         = 'command';
            $info['<command>']      = 'Ghostscript';
            $info['<command-line>'] = $exec;
            $info['<output>']       = $output;
            $info['<return-code>']  = $ret;
            $info['<language>']     = $pbxUserLanguage;
            $info['<user-name>']    = $faxJob->getUserName();
            deleteDocuments($documents);
            handleUserError($faxDatabase, $faxJob, $mailbox, $mail, $cfg, $info);
        }
        
        print "done.\n";
        
        $documents['pdf']['saved file name'] = $filePath . "/" . $jobFileName . '.pdf';
    }
    else {
        $filePdf = escapeshellcmd($documents['0']['pdf file name']);
        $documents['pdf']['saved file name'] = $documents['0']['pdf file name'];
        unset($documents['0']['pdf file name']);
    }


    print getLogDate() . "Converting $filePdf to $fileSff... ";

    $exec       = "gs -dBATCH -dNOPAUSE -sDEVICE=cfax -dAutoRotatePages=/None -dPDFFitPage -sOUTPUTFILE=$fileSff " .
        $path . DIRECTORY_SEPARATOR . ".." . DIRECTORY_SEPARATOR . "autorotate.ps $filePdf 2>&1";
    $outputs    = array();
    $ret        = false;

    exec($exec, $outputs, $ret);

    if($ret) {
        $output = "";
        foreach($outputs as &$row) {
            $output .= $row . "\n";
        }
        
        $info                   = array();
        $info['<type>']         = 'command';
        $info['<command>']      = 'Ghostscript';
        $info['<command-line>'] = $exec;
        $info['<output>']       = $output;
        $info['<return-code>']  = $ret;
        $info['<language>']     = $pbxUserLanguage;
        $info['<user-name>']    = $faxJob->getUserName();
        deleteDocuments($documents);
        handleUserError($faxDatabase, $faxJob, $mailbox, $mail, $cfg, $info);
    }
    $documents['sff']['saved file name'] = $filePath . "/" . $jobFileName . '.sff';

    print "done.\n";


    // get page count:
    $exec       = 'gs -q -dNODISPLAY -c "(' . $filePdf . ') (r) file runpdfbegin pdfpagecount = quit"';
    $outputs    = array();
    $ret        = false;

    exec($exec, $outputs, $ret);

    $pages = 0;

    if(!$ret && count($outputs)) {
        $pages = intval($outputs[0]);
    }

    if($pages) {
        print getLogDate() . "The document has " . $pages . " page" . ($pages > 1 ? "s" : "") . ".\n";
        
        // write page count in sff file:
        $fileHandle = fopen($fileSff, 'c');
        if($fileHandle) {
            if(!fseek($fileHandle, 8)) {
                fwrite($fileHandle, chr($pages % 0xFF), 1);
                fwrite($fileHandle, chr($pages / 0xFF), 1);
            }
            fclose($fileHandle);
        }
    }

    print getLogDate() . "Copying $fileSff to $fileWebdavLocal... ";

    $exec       = "cp $fileSff $fileWebdavLocal 2>&1";
    $outputs    = array();
    $ret        = false;

    exec($exec, $outputs, $ret);

    if($ret) {
        $output = "";
        foreach($outputs as &$row) {
            $output .= $row . "\n";
        }
        
        $info                   = array();
        $info['<type>']         = 'command';
        $info['<command>']      = 'Cp';
        $info['<command-line>'] = $exec;
        $info['<output>']       = $output;
        $info['<return-code>']  = $ret;
        $info['<language>']     = $pbxUserLanguage;
        $info['<user-name>']    = $faxJob->getUserName();
        deleteDocuments($documents);
        handleUserError($faxDatabase, $faxJob, $mailbox, $mail, $cfg, $info);
    }

    print "done.\n";

    deleteDocuments($documents);


    print getLogDate() . "Updating database... ";
    $faxJob->setProgress('converted');
    $faxJob->setFileName($fileWebdav);
    if($pages) {
        $faxJob->setPages($pages);
    }
    $faxJob = $faxDatabase->updateFaxJob($faxJob);
    if(!$faxJob || $faxJob->getProgress() != 'converted') {
        print "failed.\n";
        die("Could not update database object.");   
    }
    print "done.\n";
}

if($faxJob->getProgress() == 'converted') {

    $userH323       = $faxJob->getUserH323();
    $userName       = $faxJob->getUserName();
    $userNumber     = $faxJob->getUserNumber();
    $userLanguage   = $faxJob->getUserLanguage();
    $fileName       = $faxJob->getFileName();
    $pages          = $faxJob->getPages();

    for($step = 0; $step < 2; $step++) {
        $faxJob2 = &$faxJob;
        foreach($faxRecipients as $count => $recipient) {
            if($step == 0 && $count > 0) {
                unset($faxJob2);
                $newJobGuid = null;
                do {
                    $newJobGuid = createGuid();    
                    $faxJob2    = $faxDatabase->getFaxJob($newJobGuid);
                } while($faxJob2);

                $faxJob2    = $faxDatabase->addFaxJob(new InnovaphoneFaxJob($newJobGuid, 'outgoing'));
                if(!$faxJob2) {
                    die("Could not add database object.");   
                }
                $faxJob2->setMessageId($messageId);
                $faxJob2->setFileName($fileName);
                $faxJob2->setUserH323($userH323);
                $faxJob2->setUserName($userName);
                $faxJob2->setUserNumber($userNumber);
                if($userLanguage) {
                    $faxJob2->setUserLanguage($userLanguage);
                }            
                if($pages) {
                    $faxJob2->setPages($pages);
                }
            }

            if(($step == 0 && $count > 0) ||
                ($step == 1 && $count == 0))
            {
                $faxJob2->setRemoteNumber($recipient);
                $faxJob2->setProgress('queued');

                $faxJob2 = $faxDatabase->updateFaxJob($faxJob2);
                if(!$faxJob2) {
                    die("Could not update database object.");   
                }
            }
        }
    }    
    print getLogDate() . count($faxRecipients) . " fax job" . (count($faxRecipients) != 1 ? "s" : "") . " queued.\n";
}

//$faxShm->unlockJob($jobGuid);

print getLogDate() . "Finished.\n";
?>