<?php

//
// innovaphone fax poll SHM PHP script
// copyright (c) innovaphone 2011 - 2014
//

$path=dirname(__FILE__);
require_once("$path/../app-classes/innovaphone.fax.config.class.php");
require_once("$path/../app-classes/innovaphone.fax.call.class.php");
require_once("$path/../app-classes/innovaphone.fax.shm.class.php");

$version = file_get_contents("$path/../version");

declare(ticks = 1);
?>

innovaphone fax poll SHM PHP script
copyright (c) innovaphone 2011 - 2014
<?php

print "Version " . $version . "\n\n";

$help = false;
foreach($argv as $arg) {
    if(in_array($arg, array('--help', '-help', '-h', '-?'))) {
        $help = true;
    }
}

if(!is_array($_GET) && ($argc < 2 || $help)) {
?>
    Usage:
    <?php echo $argv[0]; ?> <configuration id>

    <configuration id> is the configuration id specific for this server instance.
    With the --help, -help, -h, or -? options, you can get this help.

<?php
    exit(1);
} 


setlocale(LC_CTYPE, "en_US.UTF-8");

function getLogDate() {
    $now = new DateTime();
    return date('Ymd-His') . "  -  ";
}


$configurationId        = null;
if($argc >= 1) {
    $configurationId    = intval($argv[1]);
}
else if(is_array($_GET)) {
    $configurationId    = intval($_GET['id']);
}


print "Reading configuration... ";
$cfg     = new FaxServer();
$cfg->read("", $configurationId);
if(!$cfg) {
    print "failed.\n";
    die("Could not read configuration.");
}
print "done.\n";


print "Attaching to shared memory... ";
$faxShm     = new InnovaphoneFaxShm($cfg->shmId);
if(!$faxShm->isAttached()) {
    print "failed.\n";
    die("Could not attach to the SHM.");
}
print "done.\n";


do {
    $faxShm->read();
    
    $calls = $faxShm->getCalls();
    foreach($calls as &$call) {
        $call->show();
    }

    sleep(2);

} while(true);

?>
